/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2003 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Enemy 饹(ץ쥤䡼Υ饹)Υ饤֥(Τ)                */
/*****************************************************************************/

#ifndef _NADAR_SHARE_ENEMYP_H_INCLUDED_
#define _NADAR_SHARE_ENEMYP_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "PlayerP.h"

#include "Enemy.h"

enum {
  ENEMY_STATE_DANGER = 0,  /* 򤢤餽 */
  ENEMY_STATE_ESCAPE,      /* ƨƤ */
  ENEMY_STATE_NEAR,        /* ܶ */
  ENEMY_STATE_NEAREST,     /* ܾ */
  ENEMY_STATE_CHASE,       /*  */
  ENEMY_STATE_CHASE_LEFT,  /*  */
  ENEMY_STATE_CHASE_RIGHT, /*  */
  ENEMY_STATE_BACK,        /*  */
  ENEMY_STATE_BACK_ATTACK, /* षʤ鹶 */
  ENEMY_STATE_RANDOM_WALK, /* äȤư륳 */
  ENEMY_STATE_NUM          /* ֤ο */
};

#define ENEMY_ACTIONS_BUFFER_SIZE 32

typedef struct _Enemy {
  _Player player; /* ץ쥤䡼Ѿ */

  int type; /*  */

  /*
   * ץ쥤䡼֤ϥåȤȤݻ뤳ȤǤ롥
   * ˤơߥưŪ˺뤿ᡤåȤȤݻƤ
   * ʤ(ĤäƤ뤫⤷ʤ)
   */
  Tank target;

  int state;
  int timer;

  unsigned long int actions[ENEMY_ACTIONS_BUFFER_SIZE];
  int actions_num;
  int current_action;
} _Enemy;

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_ENEMYP_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
